//
// Trace window logic
//
// Author: Jonas Tingeborn

//
var openinchrome = window.openinchrome || {};
openinchrome.Trace = (function(){
  var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService),
      FILTER_PREFIX  = "openinchrome: ",
      listener;
  
  function alert(msg){
    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    promptService.alert(window, "", msg);
  }
  
  function startEventCapture(consoleEventCallback){
    listener = {
      observe: consoleEventCallback,
      QueryInterface: function (iid) {
        if (!iid.equals(Components.interfaces.nsIConsoleListener) &&
            !iid.equals(Components.interfaces.nsISupports)) {
          throw Components.results.NS_ERROR_NO_INTERFACE;
        }
        return this;
      }
    };
    consoleService.registerListener(listener);
  }
  
  function filterMessage(msg){
    if( FILTER_PREFIX == msg.slice(0,FILTER_PREFIX.length) ) {
      return msg.slice(FILTER_PREFIX.length);
    }
  }
  
  return {
    onLoad: function(){
      startEventCapture(function(msg){
        var s = filterMessage(msg.message);
        if( !s ) return;
        window.document.getElementById('trace-box').value += s + "\n";
      });
    },
    onUnload: function(){
      consoleService.unregisterListener(listener);
    }
  };
}());

window.addEventListener("load", openinchrome.Trace.onLoad, false);
window.addEventListener("unload", openinchrome.Trace.onUnload, false);
